#include <bits/stdc++.h>
using namespace std;
#define ll long long


struct node {
    ll v;
    deque<ll> l;
    deque<ll> ans_l;
    deque<ll> ind_l;
    deque<ll> h;
    deque<ll> ind;
    ll vl = 0;
    ll vr = 0;
};

vector<ll> pref;


vector<node> p;

ll root(ll v) {
    if (p[v].v == v) {
        return v;
    }
    p[v].v = root(p[v].v);
    return p[v].v;
}

void merge(ll a,ll b) {
    a = root(a);
    b = root(b);
    if (a == b) {
        return;
    }
    for (ll i = 0; i < p[b].h.size(); i++) {
        p[a].h.push_back(p[b].h[i]);
        p[a].ind.push_back(p[b].ind[i]);
    }
    for (ll i = 0; i < p[b].h.size(); i++) {
        while (p[a].l.size() > 1 && p[a].l.front() <= p[b].h[i]) {
            p[a].l.pop_front();
            p[a].ans_l.pop_front();
            p[a].ind_l.pop_front();
        }
        ll ans = p[a].ans_l.front();
        ans += -abs(pref[p[a].ind_l.front() + 1] - pref[p[b].ind[i]]) + (
            (abs(p[a].ind_l.front() - p[b].ind[i]) - 1) * min(p[b].h[i], p[a].l.front()));
        if (p[a].l.front() < p[b].h[i]) {
            p[a].l.pop_front();
            p[a].ans_l.pop_front();
            p[a].ind_l.pop_front();
        }
        p[a].ans_l.push_front(ans);
        p[a].l.push_front(p[b].h[i]);
        p[a].ind_l.push_front(p[b].ind[i]);
    }
    p[b].v = a;
}

void merge1(ll a,ll b) {
    a = root(a);
    b = root(b);
    if (a == b) {
        return;
    }
    p[a].vr = p[b].vr;
    p[b].v = a;
}


vector<ll> tree;


void build(ll v,ll vl,ll vr) {
    if (vr - vl == 1) {
        tree[v] = 1;
        return;
    }
    ll mid = (vr + vl) / 2;
    build(v * 2, vl, mid);
    build(v * 2 + 1, mid, vr);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

void change(ll v,ll vl,ll vr,ll i) {
    if (vr - vl == 1) {
        tree[v] = 0;
        return;
    }
    ll mid = (vr + vl) / 2;
    if (mid > i) {
        change(v * 2, vl, mid, i);
    } else {
        change(v * 2 + 1, mid, vr, i);
    }
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

ll sp(ll v,ll vl,ll vr,ll i) {
    if (vr - vl == 1) {
        return vl;
    }
    ll mid = (vr + vl) / 2;
    if (tree[v * 2] >= i) {
        return sp(v * 2, vl, mid, i);
    } else {
        return sp(v * 2 + 1, mid, vr, i - tree[v * 2]);
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    p.resize(n);
    tree.resize(4 * n);
    build(1, 0, n);
    pref.resize(n + 1);
    vector<ll> h(n), k(n);
    ll e=0;
    for (ll i = 0; i < n; i++) {
        cin >> h[i];
        e=max(e,h[i]);
        pref[i + 1] = pref[i] + h[i];
        p[i].v = i;
        p[i].vl = i;
        p[i].vr = i;
        p[i].l.push_back(h[i]);
        p[i].ind_l.push_back(i);
        p[i].ans_l.push_back(0);
        p[i].ind.push_back(i);
        p[i].h.push_back(h[i]);
    }
    if (n <= 1000 || e<=10) {
        for (ll i = 0; i < n - 1; i++) {
            cin >> k[i];
            ll cnt = sp(1, 0, n, k[i] + 1);
            merge(root(cnt - 1), cnt);
            ll v = root(root(cnt - 1));
            change(1, 0, n, cnt);
            cout << p[v].ans_l.front() << endl;
        }
    } else {
        ll cc = 0;
        for (ll i = 0; i < n - 1; i++) {
            cin >> k[i];
            cc += k[i];
        }
        if (cc == n - 1) {
            for (ll i = 0; i < n - 1; i++) {
                cin >> k[i];
                ll cnt = sp(1, 0, n, k[i] + 1);
                merge(root(cnt - 1), cnt);
                ll v = root(root(cnt - 1));
                change(1, 0, n, cnt);
                cout << p[v].ans_l.front() << endl;
            }
        } else {
            ll tol = n - 1;
            ll last = 1e18;
            for (ll i = 0; i < n; i++) {
                if (h[i] <= last) {
                    last = h[i];
                } else {
                    tol = i - 1;
                    break;
                }
            }
            for (ll i = 0; i < n - 1; i++) {
                ll cnt = sp(1, 0, n, k[i] + 1);
                merge1(root(cnt - 1), cnt);
                ll v = root(root(cnt - 1));
                change(1, 0, n, cnt);
                ll ct = 0;
                if (p[v].vr >= tol && p[v].vl <= tol) {
                    if (h[p[v].vl] < h[p[v].vr]) {
                        ll l = tol;
                        ll r = p[v].vr;
                        while (r - l > 1) {
                            ll mid = (r + l) / 2;
                            if (h[mid] >= h[p[v].vl]) {
                                r = mid;
                            } else {
                                l = mid;
                            }
                        }
                        ll dist = (r - p[v].vl - 1);
                        ll mn = min(h[r], h[p[v].vl]);
                        cout << dist * mn - (pref[r] - pref[p[v].vl + 1]) << endl;
                    } else {
                        ll l = p[v].vl;
                        ll r = tol;
                        while (r - l > 1) {
                            ll mid = (r + l) / 2;
                            if (h[mid] >= h[p[v].vr]) {
                                l = mid;
                            } else {
                                r = mid;
                            }
                        }
                        ll dist = max(0ll, (-l + p[v].vr - 1));
                        ll mn = min(h[l], h[p[v].vr]);
                        cout << dist * mn - abs(pref[l + 1] - pref[p[v].vr]) << endl;
                    }
                } else {
                    cout << 0 << endl;
                }
            }
        }
    }
}

// 8
// 9 1 8 1 5 2 3 6
// 3 3 1 3 3 2 1

// 3
// 10 1 10
// 1 1